unit Unit1;

{$mode objfpc}{$H+}

interface

uses
    Windows, ShellApi, Classes, SysUtils, Forms, Controls, Graphics, Dialogs,
    StdCtrls, ComCtrls, clipbrd, activexcontainer, clipbrd_csv,
    clipbrd_xmlspreadsheet, clipbrd_settable,clipbrd_metafilepicture;

type

    { TForm1 }

    TForm1 = class(TForm)
      ActiveXContainer1: TActiveXContainer;
      Button1: TButton;
        Button3: TButton;
        Button4: TButton;
        PageControl1: TPageControl;
        TabSheet1: TTabSheet;
        procedure Button1Click(Sender: TObject);
        procedure Button2Click(Sender: TObject);
        procedure Button3Click(Sender: TObject);
        procedure Button4Click(Sender: TObject);
    private

    public

    end;

var
    Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure SetAsCSV(Html: String; const PlainText: String);
var
  Stream: TStream;
  IsValid: Boolean;
begin
  //if CF_HTML = 0 then
  //  exit;
  //If the HTML does not have correct <html><body> and closing </body></html> insert them
  //MaybeInsertHtmlAndBodyTags(HTML, IsValid);
  //if not IsValid then
  //  exit;

  {$IFDEF WINDOWS}
  Stream := TStringStream.Create(Html);
  {$ELSE}
  Stream := TStringStream.Create(Html);
  {$ENDIF}
  try
    Stream.Position := 0;
    Clipboard.AddFormat(CF_CSV, Stream);

  finally
    Stream.Free;
  end;
end;

procedure SetAsXMLSS(Html: String; const PlainText: String);
var
  Stream: TStream;
  IsValid: Boolean;
begin
  //if CF_HTML = 0 then
  //  exit;
  //If the HTML does not have correct <html><body> and closing </body></html> insert them
  //MaybeInsertHtmlAndBodyTags(HTML, IsValid);
  //if not IsValid then
  //  exit;

  {$IFDEF WINDOWS}
  Stream := TStringStream.Create(Html);
  {$ELSE}
  Stream := TStringStream.Create(Html);
  {$ENDIF}
  try
    Stream.Position := 0;
    Clipboard.AddFormat(CF_XMLSS, Stream);

  finally
    Stream.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SetAsXMLSS('1','1');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin


end;

procedure TForm1.Button3Click(Sender: TObject);
var
  ArrTable: TArrayTextTable;
  ic,ir:integer;
begin

  //Заполняем демку
  SetLength(ArrTable,7);
  for ir:=0 to 6 do
  begin
    SetLength(ArrTable[ir],3);
    for ic:=0 to 2 do
    begin
      ArrTable[ir,ic]:=Format('%d',[ic]);
    end;
  end;
  //Пишем в буфер
  ClipboardSetTable(Pointer(ArrTable));

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  GetFileFromClpb('metafilepicture.wmf',CF_METAFILEPICTURE);
  GetFileFromClpb('emetafilepicture.dat',CF_ENHANCEDMETAFILE);
end;

end.

