unit clipbrd_metafilepicture;

{$mode objfpc}{$H+}

interface

uses
    LCLType, Windows, ShellApi, Classes, SysUtils, Forms, Controls,
    Graphics, Dialogs, StdCtrls, ComCtrls,
    clipbrd;

const
  METAFILEPICTURE_FORMAT = {$IFDEF WINDOWS}'METAFILE PICTURE'{$ELSE}''{$ENDIF};

var
  cfMETAFILEPICTURE: TClipboardFormat = 0;

  function CF_METAFILEPICTURE: TClipboardFormat;
  procedure SetAsMetafile(TextData: String);

implementation

function CF_METAFILEPICTURE: TClipboardFormat;
begin
  if cfMETAFILEPICTURE = 0 then
    cfMETAFILEPICTURE := RegisterClipboardFormat(METAFILEPICTURE_FORMAT);
  Result := cfMETAFILEPICTURE;
end;

procedure SetAsMetafile(TextData: String);
var
  Stream: TStream;
  FileStream: TFileStream;
  //MyMetafile: TMetafile;
  //MyMetafileCanva: TMetafileCanvas;
  hMeta:HGLOBAL;
  hdcMeta:HDC;
  hMF:HMETAFILE;
  lpMETA:LPMETAFILEPICT;
  hwnd1:hwnd;
  hMetaGreenPen:HPEN;
  hMetaVioletBrush:HBRUSH;
  PointMeta:LPPoint;
  sTmp:string;
begin
  if CF_MetaFilePict = 0 then
    exit;
  TextData:='1';

   {MyMetafile := TMetafile.Create;
   MyMetafile.Width := 100;
   MyMetafile.Height := 100;

   MyMetafileCanva:=TMetafileCanvas.CreateWithComment(MyMetafile, 0,'Author', 'Made This');
   }
   Stream := TStringStream.Create;

   try


      hdcMeta := CreateMetaFile('test.wmf'); //
      SetWindowOrgEx(hdcMeta, 0, 0, nil);
      SetWindowExtEx(hdcMeta, 100, 100, nil);

      hMetaGreenPen := CreatePen(0, 0, $0000FF00);
      SelectObject(hDCMeta, hMetaGreenPen);

      hMetaVioletBrush := CreateSolidBrush($00FF00FF);
      SelectObject(hDCMeta, hMetaVioletBrush);

      GetCurrentPositionEx(hdcMeta, PointMeta);
      MoveToEx(hdcMeta, 0, 0, PointMeta);
      TextOut(hdcMeta, 10, 10, 'Hello People', 12);
      LineTo(hdcMeta, 10, 10);

      hMF := CloseMetaFile(hdcMeta);

      //PlayMetaFile(hdcMeta, hMF);
      {
      hMeta := GlobalAlloc(GHND, sizeof(METAFILEPICT));

      lpMeta       :=GlobalLock(hMeta);
      lpmeta^.mm   :=MM_ANISOTROPIC;
      lpmeta^.hMF  :=hMF;
      lpmeta^.xExt :=0;
      lpmeta^.yExt :=0;

      GlobalUnlock(hMeta);
      }
      sTmp:=(ExtractFilePath(Paramstr(0)))+'test.wmf';
      FileStream := TFileStream.Create(sTmp,fmOpenRead or fmShareDenyWrite);

      //if(hMeta<>0)then
      //begin
         //OpenClipboard(Application.MainForm.Handle);
         //EmptyClipboard;
         //SetClipboardData(CF_METAFILEPICT, hMeta);
         //CloseClipboard;
        //Stream.Size := 0;
        //Stream.Position := 0;
        //Stream.WriteBuffer(lpMeta, SizeOf(lpMeta)); //Also write terminating zero
        //Stream.Position := 0;
      //end;
      {}
      {MyMetafileCanva.Brush.Color := clRed;
      MyMetafileCanva.Rectangle(0,0,100,100);
      MyMetafileCanva.TextOut(   50, 50, 'Welcome to Metafile');
      //draw(0,0, image1.Picture.Bitmap);

      MyMetafile.SaveToStream(Stream); }
      {
      Stream.Size := 0;
      Stream.Position := 0;
      Stream.WriteBuffer(Pointer(TextData)^, Length(TextData)+1); //Also write terminating zero
      Stream.Position := 0;
      }
      ClipBoard.AddFormat(CF_METAFILEPICTURE, FileStream);

  finally
    // MyMetafile.
    FileStream.Free;
    Stream.Free;
  end;
end;

end.

